/**
 * Created by vitaliy on 21.09.15.
 * Прототипы и наследование
 */

var Person = {
    constructor: function(name, age, gender){
        this.name =name;
        this.age = age;
        this.gender = gender;
        return this;
    },
    sayHi: function(){
        return "Hello!!";
    }
};
var object = Object.create(Person).constructor('Vitaliy', 25,'male');
console.log(object);

console.log(Person.isPrototypeOf(object));

var WebDeveloper = Object.create(Person);
WebDeveloper.constructor = function(name, age, gender, skills){
  Person.constructor.apply(this, arguments);
    this.skills = skills|| [];
    return this;
};
WebDeveloper.develop = function(){
    return "Working...";
};
var developer = Object.create(WebDeveloper).constructor("Vasa", 44, "male", ["php", "js","css"]);
console.log(developer);
console.log(developer.develop());